A

ACCEL data structure
A data structure that defines an accelerator key used in an accelerator table.
accelerator table
An array of ACCEL data structures, each of which defines an accelerator.
Action button
A hardware navigation control on a Palm-size PC that functions like the ENTER key on a keyboard.
Active Channel
A Web site that has been enabled for Webcasting to information-receiving applications.
Active Desktop
A technology delivered in Microsoft Internet Explorer and Microsoft Pocket Internet Explorer that allows you to include HTML documents, ActiveX controls, and Java applets on your desktop.
active notification
The state of a user notification from the time the user is notified until the user handles the event. See also user notification.
Active Server Pages (ASP)
An open application environment in which HTML pages, scripts, and ActiveX components are combined to create Web-based applications.
Active Template Library (ATL)
A C++ template library used to create ActiveX servers and other Component Object Model (COM) objects. ActiveX controls created with ATL are generally smaller and faster than those created with the Microsoft Foundation Classes.
active window
In an environment capable of displaying multiple on-screen windows, the window containing the display or document that will be affected by current cursor movements, commands, and text entry. See also graphical user interface.
ActiveX
A set of technologies that enable software components to interact with one another in a networked environment, regardless of the language in which the components were created. ActiveX, which was developed as a proposed standard by Microsoft in the mid 1990s and is currently administered by the Open Group, is built on Microsoft's Component Object Model (COM). Currently, ActiveX is used primarily to develop interactive content for the World Wide Web, although it can be used in desktop applications and other applications. ActiveX controls can be embedded in Web pages to produce animation and other multimedia effects, interactive objects, and sophisticated applications. See also COM.
ActiveX client
An application or tool that calls an ActiveX object.
ActiveX object
An exposed object of the Component Object Model (COM).
ADC
See analog-to-digital converter.
address card
The fundamental unit of record in the Contacts database. Each address card contains information about an individual, such as name and address.
address mask
A number that, when compared by the computer with a network address number, will block out, or mask, all but the necessary data. For example, bits in the address corresponding to one in the mask are used, but bits corresponding to zero are ignored.
Address Resolution Protocol (ARP)
A TCP/IP protocol for determining the hardware address, or physical address, of a node on a local area network connected to the Internet, when only the IP address, or logical address, is known. An ARP request is sent to the network, and the node that has the IP address responds with its hardware address. Although ARP technically refers only to finding the hardware address, and RARP, Reversed ARP, refers to the reverse procedure, ARP is commonly used for both senses. See also IP address, TCP/IP.
Advanced Technology Attachment (ATA)
ANSI group X3T10’s official name for the disk drive interface standard commonly known as Integrated Drive Electronics (IDE). Also called AT Attachment.
American National Standards Institute (ANSI)
A voluntary, nonprofit organization of U.S. business and industry groups formed in 1918 for the development of trade and communication standards. ANSI is the American representative of the International Standards Organization and has developed recommendations for the use of programming languages including FORTRAN, C, and COBOL.
American Standard Code for Information Exchange (ASCII)
A coding scheme using 7 or 8 bits that assigns numeric values to up to 256 characters, including letters, numerals, punctuation marks, control characters, and other symbols. ASCII was developed in 1968 to standardize data transmission among disparate hardware and software systems and is built into most minicomputers and all personal computers.
analog-to-digital converter (ADC)
A device that converts an analog signal, such as sound or voltage, to binary code for use by a computer.
annunciator
An icon placed onto the taskbar to indicate that a user notification is active. Although taskbars can contain multiple annunciator icons for different applications, only one instance of an icon for any given application is displayed at one time.
ANSI
See American National Standards Institute.
apartment threading model
A threading model that can be used only on the thread that created it. See also free threading model and single threading model.
API
See application programming interface.
apogee
The point within the orbit of a satellite where the satellite is farthest from the earth.
application-defined message
A message created by an application to be used by its own windows or to communicate with windows in other processes. If an application creates its own message, the window procedure that receives the message must interpret it and provide the appropriate processing.
application notification
An application notification starts an application at a specified time or when a system event occurs. When an application starts as the result of a notification, the system specifies a command-line parameter that identifies the event that has occurred.
application programming interface (API)
A set of routines used by an application to direct the performance of procedures by a computer’s operating system. For computers running a graphical user interface, an API manages an application’s windows, icons, menus, and dialog boxes.
application-specific integrated circuit (ASIC)
An integrated circuit designed to perform a particular function by defining the interconnection of a set of basic circuit-building blocks drawn from a library provided by the circuit manufacturer.
application switch
A hardware navigation control intended to launch or reactivate software applications.
argument of the perigee
The angle, as measured from the center of the earth, between the perigee and the ascending node of orbit of a satellite. The argument of the perigee must be a value between 0 and 2 pi radians. See also ascending node and perigee.
ARP
See Address Resolution Protocol.
ascending node
The point within the orbit of a satellite where the satellite crosses the earth’s equatorial plane while travelling from south to north.
ASCII
See American Standard Code for Information Interchange.
ASIC
See application-specific integrated circuit.
ASP
See Active Server Pages.
asynchronous operation
1. A process in a multitasking system whose execution can proceed independently, or in the background. Other processes may be started before the asynchronous process has finished. 2. A data transmission method that allows characters to be sent at irregular intervals over a line by preceding each character with a start bit and following it with a stop bit. Compare synchronous operation.
ATA
See Advanced Technology Attachment.
ATAPI
The interface used by the IBM PC AT system for accessing CD-ROM devices.
ATL
See Active Template Library.
ATL for Windows CE
The Active Template Library for Windows CE. See Active Template Library.
audio driver model
The basic interface layer between the audio device drivers and the upper-layer application programming interfaces (APIs) and applications.
authentication
1. The process of verifying that a message comes from its stated source. 2. The process of verifying the identity or access level of a user, computer, or application.
Automation
A technology based on the Component Object Model (COM), that enables interoperability among ActiveX components, including OLE components. Formerly referred to as OLE Automation. See also OLE.


B

background audio source
An audio source that is not controlled by the operating system, such as a radio, a CD player, or an auxiliary input device. Background audio sources may continue playing in the background when foreground audio sources are active. See also foreground audio source.
background graphics mode
Defines how background colors are mixed with window or screen colors for text and bitmap operations. See also drawing mode.
backlight
A light source for a backlit display.
backup authority
A trusted application running on a secure computer used as a storage medium.
bandwidth
1. The difference between the highest and lowest frequencies that an analog communications system can pass. For example, a telephone accommodates a bandwidth of 3,000 Hz, which is the difference between the lowest (300 Hz) and highest (3,300 Hz) frequencies it can carry. 2. The data transfer capacity of a digital communications system.
base font
The font glyphs that you obtain from another font when performing font linking. See also linked font.
bidirectional parallel port
An interface that supports two-way parallel communications between a device and a computer.
binary image builder file (.bib)
A file used by the Windows CE ROM image builder tool to determine which modules and files to combine when forming the ROM image, and where to place the modules in memory.
binary large object (BLOB)
1. A large piece of data, such as a bitmap, characterized by large field values, an unpredictable table size, and data that is formless from the perspective of an application. 2. A keyword that designates the BLOB structure that contains information about a block of data.
bit block transfer (blit)
The process of copying the bits that constitute a bitmap from one device context to another. For example, a bit block transfer can be used to move a bitmap stored in memory to the screen for display. The bits can also be altered during a bit block transfer. As a result, light and dark portions of an image can be reversed. Successive displays can thus be used to change the appearance of an image or to move it around on the screen.
bitmap
A data structure in memory that represents information as a collection of individual bits. A bitmap represents a bit image. A bit map is also used in some systems to represent the blocks of storage on a disk, indicating whether each block is free (0) or in use (1).
blink time
The elapsed time, in milliseconds, required to invert the caret display. This value is half of the flash time.
blit
See bit block transfer.
BLOB
See binary large object.
block cipher mode
An encryption scheme in which data is encrypted one block at a time. Compare stream cipher mode.
block mode
A synchronous method of calling the CeRapiInvoke function by storing input parameters and output data in a single buffer.
boot loader
An application that is automatically run when a computer is switched on (booted). After first performing a few basic hardware tests, the boot loader loads and passes control to a larger loader application, which then typically loads the operating system. The boot loader normally resides in the computer's read-only memory (ROM).
bootstrap loader
See boot loader.
bounding rectangle
The smallest rectangle that completely surrounds an ellipse.
brush
A tool used in painting applications to sketch or fill in areas of a drawing with the color and pattern currently in use. Painting applications that offer a variety of brush shapes can produce brushstrokes of varying width and, in some cases, shadowing or calligraphic effects.
brush origin
The coordinates of a mapped pixel.
build environment
The state of the development workstation and the directory structure when an application build begins.
build window
See command prompt build window.
built-in device driver
See native device driver.


C

CA
See Certification Authority.
cabinet file
A self-contained file with a .cab extension used for application installation and setup. In a cabinet file, multiple files are compressed into one file. They are commonly found on Microsoft software distribution disks.
cache
A special memory subsystem in which frequently used data values are duplicated for quick access. A memory cache stores the contents of frequently accessed RAM locations and the addresses where this data is stored. When the processor references an address in memory, the cache checks to see whether it holds that address. If it does hold the address, the data is returned to the processor; if it does not hold the address, a regular memory access occurs. A cache is useful when RAM accesses are slow compared with the microprocessor speed, because cache memory is always faster than main RAM memory.
callback function
A function that receives messages from the operating system. Callback functions are application-defined.
caret
A flashing line, block, or bitmap that marks the location of the insertion point in a window’s client area.
cascading menu
A hierarchical graphical menu system in which a side menu of subcategories is displayed when the pointer is placed on the main category.
CDF
See Channel Definition Format.
central processing unit (CPU)
The computational and control unit of a computer. The CPU is the device that interprets and executes instructions. It has the ability to fetch, decode, and execute instructions and to transfer information to and from other resources over the computer’s main data-transfer path, the bus. By definition, the CPU is the chip that functions as the “brain” of a computer. In some instances, however, the term encompasses both the processor and the computer’s memory or, even more broadly, the main computer console, as opposed to peripheral equipment.
certificate
A packet of data containing a public key and identification information. Every certificate is created and signed by Certification Authorities.
Certification Authority (CA)
An entity that attests to the identity of a person or an organization. The Certification Authority’s primary function is to verify the identity of entities and issue digital certificates attesting to that identity.
Cesh
The Windows CE Debug Shell Tool (Cesh.exe). This shell enables you to transfer an operating system image from the development workstation to the target platform and provides you with a set of commands to assist in debugging processes running on the target platform.
channel
A subscription to a Web site that conforms to the Channel Definition Format.
Channel Definition Format (CDF)
A specification developed by Microsoft and presented to the World Wide Web Consortium (W3C) that allows applications to send Web pages to users. Once a user subscribes to a CDF channel, any software that supports the CDF format automatically receives any new content posted on the channel’s Web server. The default client subscription application for Internet channel broadcasting in Broadcast Architecture stores subscription information as .cdf files.
channel script
An application written in HTML that uses Visual Basic Script, JScript, Java Script, and other scripting languages to specify the layout and behavior of a channel.
channel synchronization
The process of first downloading Mobile Channels content into a cache using the standard Internet Explorer 4.0 channel retrieval mechanism and then transferring it onto a Windows CE–based device. Channel synchronization makes it possible for users to access Mobile Channels using either a Windows CE–based device without a radio module or a Windows-based desktop computer when the device is not readily available. See also Mobile Channels.
check box
An interactive control found in graphical user interfaces. Check boxes are used to enable or disable one or more features or options from a set. When an option is selected, an x or a check mark appears in the box.
child window
A window that has the WS_CHILD style. A child window always appears within the client area of its parent window.
chord
A combination of navigation controls used to perform a defined function. A chord is functionally similar to a keyboard accelerator. For example, on some Palm-size PCs, pressing and holding an Action button and then pressing an Exit button toggles the backlight.
CIFS
See Common Internet File System.
CIFS redirector
A module through which one computer gains access to another. Its function is to reestablish disrupted connections and to package and send remote file-system requests to host targets.
cipher mode
A method used to encrypt data.
ciphertext
Data that has been encrypted.
class identifier (CLSID)
A universally unique identifier (UUID) that identifies a type of Component Object Model (COM) object. Each type of COM object item has its CLSID in the registry so that it can be loaded and used by other applications. For example, a spreadsheet may create worksheet items, chart items, and macrosheet items. Each of these item types has its own CLSID that uniquely identifies it to the system.
client
1. In object-oriented programming, a member of a class (group) that uses the services of another class to which it is not related. 2. A process, such as an application or task, that requests a service provided by another application. For example, a word processor that calls on a sort routine built into another application. The client process uses the requested service without having to know any working details about the other application or the service itself. 3. On a local area network or the Internet, a computer that accesses shared network resources provided by another computer, called a server.
client area
The client area is the portion of a window where the application displays output, such as text or graphics. Also called a client rectangle.
client coordinate
A coordinate that is relative to the upper-left corner of a window’s client area.
clipping region
A subregion of the client area to which output is restricted. Clipping is used in Windows CE in a variety of ways. For example, word processing and spreadsheet applications clip keyboard input to keep it from appearing in the margins of a page or spreadsheet.
CLSID
See class identifier.
code element
The smallest component of a written language that has semantic value. See also codespace and code value.
codespace
The logical grouping of code elements throughout the range of supported Unicode code values. See also code element and code value.
code value
A single 16-bit number assigned to each code element that is defined by the Unicode standard. When referred to in text, each code value is listed in hexadecimal form following the prefix U. See also code element and codespace.
cold boot
A startup process that begins with turning on the computer’s power. Typically, a cold boot involves some basic hardware checking by the system, after which the operating system is loaded from disk into memory. Compare warm boot.
COM
See Component Object Model.
COM class
The definition of an object in code. In COM, class refers to the general object definition, whereas in C++, the class of an object is a data type.
COM object
A programming structure that includes both data and functionality. A COM object is defined and allocated as a single unit. The only public access to a COM object is through the programming structure’s interfaces. At a minimum, a COM object must support the IUnknown interface, which maintains the object’s existence while it is being used and provides access to the object’s other interfaces.
COM port
Short for communications port, the logical address assigned by MS-DOS versions 3.3 and later, and Microsoft Windows to each of the four serial ports on an IBM personal computer or an IBM PC–compatible computer. COM ports also have come to be known as the actual serial ports on a computer’s CPU where peripherals, such as printers, scanners, and external modems, are plugged in.
combo box
A control that combines an edit control with a list box. This allows the user to type in an entry or choose one from the list.
command band
A rebar control with a fixed band at the top that contains a toolbar with a Close (X) button, an OK button, and optionally, a Help (?) button in the upper-right corner.
command bar
A control window that can contain buttons, combo boxes, and menu bars. Windows CE–based applications can use a command bar rather than a separate menu and toolbar to efficiently utilize available screen space.
command prompt build window
A development workstation command prompt window from which the Platform Builder user has run the Wince.bat tool. Also called build window.
common control
A standardized child window that an application uses in conjunction with another window to perform input/output tasks. A common control enables users to view and organize information and to set or change attributes and properties. Most common controls send the WM_NOTIFY message.
Common Internet File System (CIFS)
A standard proposed by Microsoft that would compete directly with Sun Microsystems’ Web Network File System. A system of file sharing of Internet or intranet files.
Compact Flash
A group of related technologies for providing long-term storage through various types of nonvolatile memory.
component
A subset of the Windows CE operating system. Windows CE is structured as a collection of modules that are subdivided into smaller components. Each module and component is a self-contained subset of the Windows CE operating system that can be used to construct a customized operating system for a particular device.
Component Object Model (COM)
An open architecture for cross-platform development of client/server applications. It is based on object-oriented technology as agreed upon by Digital Equipment Corporation and Microsoft Corporation. COM defines the interface, similar to an abstract base class, IUnknown, from which all COM-compatible classes are derived.
compound file
A number of individual files bound together in one physical file where each individual file can be accessed as if it were a single physical file.
connection-based session
A communications session that requires a connection to be established between hosts prior to an exchange of data.
connectionless session
A communications session that does not require a connection to be established between hosts prior to an exchange of data.
Contacts database
A collection of names, addresses, telephone numbers, and other information stored on a Windows CE device by the Contacts application. The database is divided into a set of records called address cards. The database contains any number of address cards, limited only by the amount of memory available on the device.
container
A network resource that contains other resources.
continuous resistive touch panel
See touch screen.
control
A standardized child window on the screen that can be manipulated by the user to perform an action or display information. The most common controls are buttons, which allow the user to select options, and scroll bars, which allow the user to move through a document or position text in a window.
control identifier
A value that uniquely identifies a control.
control style
A value, similar to a window style, that specifies the appearance and behavior of a control. The window procedure for the control uses the style to determine how to draw the control and process input.
cookie
A block of data a Web server stores on a client system. When a Web client user returns to the Web server site, the browser sends a copy of the cookie to the server. Cookies identify users, instruct the server to send a customized version of the requested Web page, submit account data for the user, and fulfill other administrative purposes.
CPU
See central processing unit.
credential
Data used by a principal to establish the identity of the principal, such as a password or user name.
critical section
An object that protects a section of code from being accessed by more than one thread. A critical section is limited to only one process or dynamic-link library (DLL) and cannot be shared with other processes.
cryptographic service provider (CSP)
An independent module that performs cryptographic operations, such as creating and destroying keys. A cryptographic service provider consists of, at a minimum, a dynamic-link library (DLL) and a signature file.
CSP
See cryptographic service provider.
cursor
A small bitmap whose location on the screen is controlled by a pointing device, such as a mouse, pen, or trackball. Some Windows CE–based platforms support only the wait cursor—the spinning hourglass.
custom command
A speech command that is trained by the user. A custom command has a speaker-dependent template.


D

database synchronization
The process of bringing two separate copies of a database into agreement.
database system application programming interface
A set of functions that enable you to create and manipulate Windows CE databases. Each database consists of an arbitrary number of records, and each record consists of at least one property.
database type identifier
A user-specified token, or number, that is attached to a database. The token can be used to identify related databases by associating the same value, or related values, with each database.
datagram
A data packet, containing sufficient delivery information, that can be routed through a packet-switching network without reliance on exchanges between the source and destination computer.
data link
A connection between any two devices capable of sending and receiving information, such as a computer and a printer or a main computer and a terminal. Sometimes the term is extended to include equipment, such as a modem, that enables transmission and receiving. Such devices follow protocols that govern data transmission.
date and time picker control (DTP)
A control that displays information about dates and times, and provides users with an easy way to modify this information.
datum
A frame of reference for coordinates used to describe horizontal or vertical position on or near the surface of the earth.
DCC
See direct cable connection.
DDB
See device-dependent bitmap.
DDE
See dynamic data exchange.
DDI
See device driver interface.
DDK
See Device Driver Kit.
DDTK
See Device Driver Test Kit.
dead key
A key used with another key to create an accented character. A dead key, when pressed, produces no visible character, but indicates that the accent mark it represents is to be combined with the character produced by the next letter key pressed.
decryption
The process of returning encrypted data to its original form.
de-emphasis
Resets the signal magnitude on an audio channel. Compare pre-emphasis.
derived session key
A session key created by an application as needed. Before creating a derived session key, an application prompts the user for a password.
deserialize
The process of converting a series of bytes back into an object. Compare serialize.
desktop
An on-screen work area that uses icons and menus to simulate the top of a desk. Its intent is to make a computer easier to use by enabling users to move pictures of objects and to start and stop tasks in much the same way as they would if they were working on a physical desktop.
desktop connectivity
The services required to connect a Windows CE–based device to a desktop computer.
desktop provider module
One of two DLLs that comprise a service provider. The desktop provider module handles the bulk of communication with the service manager and implements two COM interfaces. See also service provider and service manager.
development workstation
The PC-based computer on which you install Windows CE development toolkits and develop software for your Windows CE–based platform.
device
1. A generic term for a computer subsystem. Printers, serial ports, and disk drives are often referred to as devices; such subsystems frequently require their own controlling software, called device drivers. 2. A hardware feature that can—or must—be part of the target platform. For example, a built-in device could be a low-battery notification LED, while a PC Card modem is an installable device. See also device driver.
device context
A GDI structure containing information that governs the display of text and graphics on a particular output device. A device context stores, retrieves, and modifies the attributes of graphic objects and specifies graphic modes. The graphic objects stored in a device context include a pen for line drawing, a brush for painting and filling, a font for text output, a bitmap for copying or scrolling, a palette for defining the available colors, and a region for clipping.
device-dependent bitmap (DDB)
An array of bits that can only be used with a particular display or printer.
device driver
A software component that permits a computer system to communicate with a device. In most cases, the driver also manipulates the hardware in order to transmit the data to the device. However, device drivers associated with application packages typically perform only the data translation; these higher-level drivers then rely on lower-level drivers to actually send the data to the device. Many devices will not work properly—if at all—without the correct device drivers installed in the system.
device driver interface (DDI)
1. The interface between applications and the device drivers. 2. A set of functions implemented in the model device driver and called by the Graphics, Windowing, and Events Subsystem (GWES).
Device Driver Kit (DDK)
A set of tools and libraries that enable programmers to write Windows-based software used to run hardware devices such as printers.
Device Driver Test Kit (DDTK)
A set of tools and libraries that enable you to test the porting of your device drivers to the Windows CE operating system.
device-independent bitmap (DIB)
An array of bits combined with several structures that specify the width and height of the bitmap image (in pixels), the color format of the device with which the image was created, and the resolution of the device used to create that image. A DIB generally has its own color table, and can therefore be displayed on a variety of devices.
device manager
An application, included on all Windows CE–based platforms, that manages stream interface device drivers. The device manager handles loading and unloading stream interface device drivers, identifying the correct driver for plug-and-play devices, managing running device drivers, and notifying stream interface device drivers of power-up and power-down events.
device partnership
A device partnership is a registry key on a Windows CE device that a desktop computer uses to identify a Windows CE device to which a desktop computer is connected. The key defines values for synchronization, file conversions, and backup and restore information, which enable multiple Windows CE devices to connect to the same desktop computer. A device partnership is created the first time you connect a Windows CE device to a desktop computer.
device provider module
One of two DLLs that comprise a service provider. The device provider module handles communication between the service manager and the device. See also service provider and service manager.
DHCP
See Dynamic Host Configuration Protocol.
dialog box
A temporary window that contains controls. You can use it to display status information and to get user input.
dialog box procedure
An application-defined callback function that the system calls when it has input for a dialog box or has tasks for a dialog box to carry out.
dialog box template
A binary description of a dialog box and the controls it contains. You can create this template as a resource to be loaded from the application’s executable file, or created in memory while the application runs.
DIB
See device-independent bitmap.
digital signature
Binary data attached to a message that uniquely identifies a sender. A digital signature can be used with hash values to ensure that a transmitted message has not been tampered with.
direct cable connection (DCC)
A RAS networking connection between two computers, or between a computer and a Windows CE–based device, which uses a serial or parallel cable directly connected between the systems instead of a modem and a phone line.
direct memory access (DMA)
Memory access that does not involve the microprocessor and is frequently used for data transfer directly between memory and an “intelligent” peripheral device, such as a disk drive.
discrete speech recognition
Speech recognition that recognizes words that are delineated by pauses.
DLL
See dynamic-link library.
DMA
See direct memory access.
DNS
See Domain Name System.
Domain Name System (DNS)
A name service that resolves system names to current IP addresses and uses a tiered or hierarchical model to pass name resolutions between domains.
dotted decimal notation
The process of formatting an Internet Protocol (IP) address as a 32-bit identifier made up of four groups of numbers, with each group separated by a period. For example, 123.432.154.12.
drag-and-drop
A technique for moving or copying data between applications, between windows within an application, or within a single window in an application. The user selects the data to be transferred and drags the data to the desired destination. Windows CE supports drag-and-drop operations. However, nondefault drag-and-drop operations, equivalent to right mouse button drag-and-drop operations, are not supported.
drawing mode
Defines how foreground colors are mixed with window or screen colors for pen, brush, bitmap, and text operations. See also background graphics mode.
drop-down menu
A menu that drops from the menu bar when requested and remains open without further action until the user closes it or chooses a menu item.
DTP control
See date and time picker control.
dummy file filter
A means for transferring files of nonstandard or possibly unknown extensions for which no translation is necessary. Passing the file through the dummy filter keeps the No Convertor Selected dialog box from appearing.
dynamic data exchange (DDE)
An interprocess communication method that allows two or more applications running simultaneously to exchange data and commands.
Dynamic Host Configuration Protocol (DHCP)
A TCP/IP protocol that enables a network connected to the Internet to automatically assign a temporary Internet protocol (IP) address to a host when the host connects to the network.
dynamic-link library (DLL)
A set of autonomous functions that any application can use. DLLs are a set of source code modules with each module containing a set of functions.


E

ECB
See Electronic Codebook.
eccentricity
A value that specifies how much the shape of the elliptical orbit of a satellite deviates from a circular path. Eccentricity equals the distance between the foci of the orbital ellipse divided by one-half the length of the major axis of the orbital ellipse. The eccentricity must be between 0 and 1. Values closer to 0 indicate that the orbit is closer to a circular path. See also focus and major axis.
edit control
A rectangular window in which a user can enter and edit text from the keyboard. An edit control is also referred to as a text box.
Electronic Codebook (ECB)
A cipher mode in which each plaintext block is encrypted individually. ECB uses no feedback. This means that blocks of plaintext that are identical, either in the same message or in a different message encrypted with the same key, are transformed into identical cipher blocks. Initialization vectors cannot be used with the ECB cipher mode. If a single bit of the cipher block is garbled, then the entire corresponding plaintext block is also garbled.
embedded
Software code or commands built into their carriers. For example, applications insert embedded printing commands into a document to control printing and formatting. Low-level assembly is embedded in higher-level languages, such as C, to provide more capabilities or better efficiency.
encryption
The process of transforming data into a form unreadable by anyone without a secret key.
engine
1. A section of an application that determines how that application manages and manipulates a type of data. 2. An application or module with an open API to which an application passes data in order to access the engine’s processing capabilities.
environment variable
An element of the operating system environment, such as a path, a directory name, or a configuration string. Environment variables are typically set within batch files.
Ethernet
A widely used LAN developed by Xerox, Digital, and Intel. Ethernet networks connect up to 1,024 nodes at 10 megabits per second over twisted pair, coaxial cable, and optical fiber.
event
An event is an occurrence that triggers a notification. Windows CE supports timer and system events.
event-driven operating system
An operating system that constantly evaluates and responds to sets of events, such as key presses or mouse movements.
event object
A synchronization object that enables one thread to notify another that an event has occurred. Event objects are useful when a thread needs to know when to perform its task. For example, a thread that copies data to an archive needs to be notified when new data is available. By using an event object to notify the copying thread of the availability of new data, the thread can perform its task as soon as possible.
exception handling
The process of dealing with exceptions, or errors, as they arise during application execution. Exceptions occur when an application executes abnormally due to conditions outside the application’s control. Windows CE does not support C++ exception handling.
execute in place (XIP)
The process of executing code directly from read-only memory (ROM), rather than loading it from random access memory (RAM) first. Executing the code in place, instead of copying the code into RAM for execution, saves system resources. Applications in other file systems, such as on a PC Card storage device, cannot be executed in this way.
Exit button
A hardware navigation control that functions as the ESC key on a keyboard.
extension key
An entry in the registry, corresponding to the extension of a given file, that specifies which file filter will handle conversions for that file type.


F

FAT
See file allocation table.
file allocation table (FAT)
A table or list maintained by some operating systems to manage disk space used for file storage. Files on a disk are stored, as space allows, in fixed-size groups of bytes (characters) rather than from beginning to end as contiguous strings of text or numbers. A single file can thus be scattered in pieces over many separate storage areas. A file allocation table maps available disk storage space so that it can mark flawed segments that should not be used and can find and link the pieces of a file. In MS-DOS, the file allocation table is commonly known as the FAT.
file filter
A Windows CE dynamic-link library (DLL) that controls the transfer of data between a desktop computer and a Windows CE–based device.
file handle
A token, or number, that the operating system uses to identify or refer to an open file or, sometimes, to a device.
file pointer
The offset into an open file that the operating system maintains internally. It points to the starting location where data is read from or written to when a read or write operation is performed on an open file. The file pointer can be moved to any location within the file by a seek operation.
file system
In an operating system, the overall structure in which files are named, stored, and organized. A file system consists of files, directories, and the information needed to locate and access these items. The term can also refer to the portion of an operating system that translates requests for file operations from an application into low-level, sector-oriented tasks that can be understood by the drivers controlling the disk drives.
file system application interface
A subset of the standard Win32 file system functions. These functions let you create directories and data files, read and write file data, and retrieve file and directory information.
file system driver (FSD)
A user-written DLL that the operating system loads to interface to a user-created installable file system. The functions that access an installable file system are implemented in the DLL. See also installable file system.
File Transfer Protocol (FTP)
The protocol used for copying files to and from remote computer systems on a network using a Transmission Control Protocol/Internet Protocol (TCP/IP), such as the Internet. This protocol also allows users to use FTP commands to work with files, such as listing files and directories on the remote system.
firmware
Software routines stored in read-only memory (ROM). Unlike random access memory (RAM), read-only memory stays intact even in the absence of electrical power. Startup routines and low-level input/output instructions are stored in firmware. It falls between software and hardware in terms of ease of modification. See also RAM and ROM.
first order clock correction
A measurement of how much the atomic clock on a Global Positioning System (GPS) satellite drifts over time.
flash card
See PC Card storage device.
flash memory
Semiconductor memory that can operate as ROM but, on an activating signal, can rewrite its contents as though it were RAM.
flash time
The elapsed time, in milliseconds, required to display, invert, and restore the caret display. This value is twice as much as the blink time.
focus
One of the two points that determine the shape of an ellipse. The sum of the distances between any point on the ellipse and each of the foci is constant.
focus window
The window that is currently receiving keyboard input. The focus window is always the active window, a descendant of the active window, or NULL.
font mapping
The process of matching an application-defined description of a font with a font that is physically stored on a device or in an operating system. An application-defined font is called a logical font and a font on a device or in an operating system is called a physical font. See also logical font and physical font.
foreground audio source
An audio source that is controlled entirely by the operating system, such as speech recognition tones and text-to-speech (TTS). Depending on user settings, a foreground audio source can partially or fully mute background audio sources while they play. See also background audio source.
foreground thread
The thread used to create the window with which the user is currently working.
foreground window
The window with which the user is currently working. The system assigns a slightly higher priority to the thread used to create the foreground window than it does to other threads.
form
An ActiveX control container that you customize to create a user interface for your application. A form contains a collection of controls, such as speech controls, power list boxes, audio controls, and tabber controls. A form displays information on a screen.
Forms Manager
An ActiveX control container that manages forms, providing focus management, menus, help, and event sinks.
fragmentation
The process of separating a datagram into smaller pieces for routing between networks.
free threading model
A model in which an object can be used on any thread at any time. See also apartment threading model and single threading model.
FSD
See file system driver.
FTP
See File Transfer Protocol.


G

gateway
A device that connects networks using different communications protocols.
GDI
See graphics device interface.
GDOP
See geometric dilution of precision.
geoid
A model for the surface of the earth based on gravitational factors. A geoid approximates a sea-level surface and is the reference for most land elevations and ocean depths that appear on maps and charts.
geometric dilution of precision (GDOP)
A numerical factor that specifies the portion of the error in a Global Positioning System (GPS) position, and time measurement that results from the geometry of the GPS satellites used to make the measurement.
Global Positioning System (GPS)
A space-based radio navigation system that consists of 24 satellites and ground support. This system provides a user with accurate information about vehicle position and velocity.
globalization
The process of developing an application core whose feature and code designs do not make assumptions based on a single language or locale, and whose source code simplifies the creation of different language editions of an application.
global variable
A variable whose value can be accessed and modified by any statement in an application, and not merely within a single routine in which it is defined.
GPS
See Global Positioning System.
graphics device interface (GDI)
The Windows CE subsystem responsible for displaying text and images on display devices and printers. The GDI processes graphical function calls from a Windows-based application. It then passes those calls to the appropriate device driver, which generates the output on the display hardware. By acting as a buffer between applications and output devices, the GDI presents a device-independent view of the world for the application while interacting in a device-dependent format with the device. Because of the smaller memory footprint of Windows CE–based devices, Windows CE supports only a subset of the standard Win32 GDI.
graphics object
The pen, brush, bitmap, palette, region, font, and path associated with a device context. Windows CE does not support paths.
Graphics, Windowing, and Events Subsystem (GWES)
The Windows CE module that contains the graphics and windowing functionality needed to display text and images and to receive user input. It includes all the functionality needed to create and manage windows, controls, dialog boxes, and resources such as icons and menus. It also processes all user input. GWES includes the graphics device interface, which displays text and images on display devices and printers.
grayscale
A sequence of shades ranging from black through white, used in computer graphics to add detail to images or to represent a color image on a monochrome output device. Like the number of colors in a color image, the number of shades of gray depends on the number of bits stored per pixel. Grays may be represented by actual gray shades, by halftone dots, or by dithering.
gripper bar
A gripper bar is a tall, thin rectangle with a dark stripe running through it that appears on a rebar or a command band control. By touching and dragging a gripper bar with a stylus, a user can reposition a rebar or command bar. Gripper bars are especially useful for bringing off-screen rebar or command bar controls into view.
group box
A rectangular area within a dialog box in which you can group together other controls that are semantically related. The controls are grouped by drawing a rectangular border around them. Any text associated with the group box is displayed in its upper-left corner.
GUID
A globally unique identifier. See universally unique identifier.
GWES
See Graphics, Windowing, and Events Subsystem.


H

HAL
See hardware abstraction layer.
handle
1. A pointer to a pointer; that is, a variable that contains the address of another variable, which in turn contains the address of the desired object. In certain operating systems, the handle points to a pointer stored in a fixed location in memory, whereas that pointer points to a movable block. If applications start from the handle whenever they access the block, the operating system can perform memory management tasks such as garbage collection without affecting the applications. 2. Any token that an application can use to identify and access an object such as a device, a file, a window, or a dialog box. 3. One of several small squares displayed around a graphical object in a drawing application. The user can move or reshape the object by clicking on a handle and dragging.
hardware abstraction layer (HAL)
Provides high-level access and control of various audio devices. HAL allows an application to communicate with various audio devices in a standard way.
hash value
A value used in creating digital signatures. This value is generated by imposing a hashing algorithm onto a message. This value is then transformed, or signed, by a private key to produce a digital signature. Also called message digest.
hashing algorithm
A formula used to generate hash values and digital signatures.
header control
A horizontal window that is usually positioned above columns of data. It is divided into partitions that correspond to the columns, and each partition contains the title for the column below it.
heap
A portion of memory reserved for an application to use for the temporary storage of data structures whose existence or size cannot be determined until the application is running. The application can request free memory from the heap to hold such elements, use it as necessary, and later free the memory.
hibernation
The way in which a Windows CE–based device manages a memory shortage by requesting applications to free memory that is not currently needed.
hibernation threshold
The point at which the system enters a limited-memory state.
high-resolution performance counter
Hardware that provides high-resolution timing, which is useful in improving the performance of applications.
High Sierra Specification
An industrywide format specification for the logical structure, file structure, and record structure on a compact disc.
H/PC
A Handheld PC.
hook
A location in a routine or application in which the programmer can connect or insert other routines for the purpose of debugging or enhancing functionality.Windows CE does not support hooking.
host
A device on a TCP/IP network that can be identified by a logical IP address.
host identifier
An address that identifies a workstation, server, router, or other TCP/IP host within a network. Each host address must be unique to the network identifier.
hot key
A keystroke or combination of keystrokes that switches the user to a different application, often a terminate-and-stay-resident (TSR) application or the operating system user interface. Hot keys generate a WM_HOTKEY message.
hot spot
The pixel in a cursor that marks the exact screen location affected by a mouse or pen action, such as a button click. Messages include the coordinates of a hot spot.
HTML
See Hypertext Markup Language.
HTTP
See Hypertext Transfer Protocol.
Hypertext Markup Language (HTML)
A markup language derived from the Standard Generalized Markup Language (SGML). Used to create a text document with formatting specifications that tells a software browser how to display the page or pages included in the document.
Hypertext Markup Language (HTML) viewer control
1. A control that provides programmers with the ability to implement the Windows CE Pocket Internet Explorer and the Help engine. It also provides independent software vendors (ISVs) with the ability to implement additional viewers based on the HTML viewer control. 2. A control that enables a user to render HTML text, display embedded images, and notify an application of user events.
Hypertext Transfer Protocol (HTTP)
The client/server protocol used to access information on the Web.


I

IAS
See Information Access Service.
ICMP
See Internet Control Message Protocol.
icon
A small image displayed on the screen to represent an object that can be manipulated by the user. By serving as visual mnemonics and allowing the user to control certain computer actions without having to remember commands or type them at the keyboard, icons are a significant factor in the user-friendliness of graphical user interfaces.
IDE
See integrated development environment and Integrated Device Electronics.
idle priority
One of three thread priority groups. Idle priority indicates that a thread’s processing can wait until all other threads have finished running. See also interrupt priority and main priority.
IEEE
See Institute of Electrical and Electronics Engineers.
IHV
See independent hardware vendor.
IIS
See Internet Information Server.
IM
See input method.
image list
A collection of images that are all the same size, such as bitmaps or icons.
IME
See Input Method Editor.
IMM
See Input Method Manager.
Inbox
A mail client application provided with Windows CE.
inclination
A measurement that describes the angle formed between the plane defined by the orbit of a satellite and the equatorial plane of the earth. The value of the inclination must be between 0 and pi radians.
independent hardware vendor (IHV)
A company that manufactures devices that connect to Windows CE–based platforms, such as PC Card storage devices. IHVs must also produce stream interface device drivers for their devices. See also stream interface device driver.
.inf
A CAB Wizard input file that specifies information about the application.
Information Access Service (IAS)
A part of an IrDA infrared communication protocol used so that devices can learn about the services offered by another device. See also Infrared Data Association.
infrared (IR)
Of or relating to the range of invisible radiation wavelengths from about 750 nanometers, just longer than red in the visible spectrum, to 1 millimeter, on the border of the microwave region.
Infrared Data Association (IrDA)
The industry organization of computer, component, and telecommunications vendors who have established the standards for infrared communication between computers and peripheral devices such as printers. Windows CE supports the IrDA standard through the Winsock application programming interface (API). Windows CE–based applications that communicate over serial cables using the Winsock API communicate over IrDA-compliant IR links with only minimal reprogramming.
Infrared Link Access Protocol (IrLAP)
A protocol, based on the High-level Data Link Control (HDLC) protocol, designed to control an infrared link. IrLAP provides for discovery of devices, their connection over an infrared link, and reliable data delivery between devices.
Infrared Link Management Protocol (IrLMP)
A service multiplexing protocol that provides for multiple sessions over a single point-to-point link.
Infrared Sockets (IrSock)
An implementation of the Winsock protocol.
.ini
An initialization file that registers an application with an application manager. It contains information such as the location of .cab files, icon files, and the installation directory.
initialization vector
A random number used as a starting point when encrypting data. Two identical packets of data encrypted with the same key can result in two different packets of ciphertext, if each packet of data is encrypted with different initialization vectors.
input context
An internal structure, maintained by the IME, that contains information about the status of the IME and is used by IME windows. By default, the system creates and assigns an input context to each thread. Within the thread, this default input context is a shared resource and is associated with each newly created window.
input method (IM)
A COM component that allows the user to input text using a touch screen. For example, a Palm-size PC supports input methods for a graphical representation of a keyboard and a character recognizer.
Input Method Editor (IME)
An engine that converts keystrokes into phonetic and ideograph characters, along with a dictionary of ideograph words, for conversion of characters into non-Roman, particularly Asian, characters.
Input Method Manager (IMM)
A component supported in Windows CE version 2.10 and later that handles communication between IMEs and applications.
input panel
A window control that supports various input methods, such as writing or drawing.
installable device driver
See stream interface device driver.
installable file system
A file system that is accessed through a file system driver (FSD) that is loaded onto a device by the user, rather than accessed by the built-in file system. An installable file system may be implemented differently from the built-in file system. For example, an installable file system may prevent a user from deleting files, provide automatic compression of files, or use a structure for internal information different from that used by the built-in file system. See also file system driver.
installable file system driver
See file system driver.
Institute of Electrical and Electronics Engineers (IEEE)
An organization of professional electrical and electronics engineers that is notable for developing standards for hardware and software.
integrated development environment (IDE)
In the Microsoft Developer Studio, an integrated set of Windows-based tools for building, testing, and refining an application. The IDE includes a variety of editors, project build facilities, compilers, an incremental linker (for C++), a class viewer, and an integrated debugger. The IDE enables you to create, test, and refine your applications and Web sites all in one place.
Integrated Device Electronics (IDE)
A type of disk-drive interface in which the controller electronics reside on the drive itself, eliminating the need for a separate adapter card.
interface
1. The point at which a connection is made between two elements so that they can work with one another. 2. Software that enables an application to work with the user (the user interface, which can be a command-line interface, menu-driven, or a graphical user interface), with another application, such as the operating system, or with the computer’s hardware. 3. A card, plug, or other device that connects pieces of hardware with the computer so that information can be moved from place to place. 4. A networking or communications standard that defines ways for different systems to connect and communicate.
Internet Control Message Protocol (ICMP)
A network-layer Internet protocol that provides error correction and other information relevant to Internet Protocol (IP) packet processing, such as testing whether a particular computer is connected to the Internet (pinging) by sending a packet to its IP address and waiting for a response. For example, it can let the IP software on one machine inform another machine about an unreachable destination. See also ping.
Internet Information Server (IIS)
Microsoft's brand of Web server software, using Hypertext Transfer Protocol (HTTP) to deliver World Wide Web documents. It incorporates various functions for security, allows for CGI applications, and also provides for Gopher and File Transfer Protocol (FTP) servers.
Internet Protocol (IP)
Provides the protocol for connecting hosts over a network, breaking messages into packets, addressing the packets, routing them from the sender to the destination network, and reassembling the packets into the original message at the destination. IP corresponds to the network layer in the International Organization for Standardization Open Systems Interconnection (ISO/OSI) model. See also ISO/OSI model.
Internet Protocol (IP) address
A 32-bit (4-byte) binary number that uniquely identifies a host computer connected to the Internet to other Internet hosts, for the purposes of communication through the transfer of packets. An IP address is expressed in “dotted quad” format, consisting of the decimal values of its four bytes, separated with periods; for example, 127.0.0.1. The first one, two, or three bytes of the IP address, assigned by InterNIC Registration Services, identify the network the host is connected to; the remaining bits identify the host itself.
internetwork
Of or pertaining to communications between connected networks. Often used to refer to communication between one local area network and another over the Internet or another wide-area network.
interrupt
A request for attention from the processor. When the processor receives an interrupt, it suspends its current operations, saves the status of its work, and transfers control to a special routine known as an interrupt handler, which contains the instructions for dealing with the particular situation that caused the interrupt. Interrupts can be generated by various hardware devices to request service or report problems, or by the processor itself in response to application errors or requests for operating-system services. Interrupts are the processor’s way of communicating with the other elements that make up a computer system. A hierarchy of interrupt priorities determines which interrupt request will be handled first if more than one request is made. An application can temporarily disable some interrupts if it needs the full attention of the processor to complete a particular task.
interrupt identifier (interrupt ID)
A unique value used by the kernel to identify the device that raised the interrupt and that requires more processing. The kernel then uses the interrupt identifier to indicate whether all handling is complete, or whether to launch an interrupt service thread that handles further processing by the device driver.
interrupt priority
One of three thread priority groups. Interrupt priority is reserved for operating system threads. See also idle priority and main priority.
interrupt request line (IRQ)
A hardware line over which a device, such as an I/O port, keyboard, or disk drive, can send interrupt requests to the CPU. Interrupt request lines are built into the computer’s internal hardware and are assigned different levels of priority so that the CPU can determine the sources and relative importance of incoming service requests.
interrupt service routine (ISR)
A small subroutine that resides in the OEM adaptation layer (OAL). The ISR executes in kernel mode and has direct access to the hardware registers. Its sole job is to determine what interrupt identifier to return to the interrupt support handler. Essentially, ISRs map physical interrupts onto logical interrupts.
interrupt service thread (IST)
A thread created by a device driver to wait on an event.
interrupt support handler
A routine that registers a driver so that it can handle a particular interrupt and deregister it later. It also enables communication between the interrupt service routine, the interrupt service thread, and subroutines within the OEM adaptation layer (OAL).
I/O
Input/output.
IP
See Internet Protocol.
IR
See infrared.
IrCOMM
An infrared implementation of the serial line communication driver. IrCOMM is supported by Windows CE.
IrDA
See Infrared Data Association.
IrLAP
See Infrared Link Access Protocol.
IrLMP
See Infrared Link Management Protocol.
IrLPT
A protocol for printing through a serial infrared connection.
IRQ
See interrupt request line.
IrSock
See Infrared Sockets.
ISO/OSI model
A layered architecture that standardizes levels of service and types of interaction for computers exchanging data through a communications network. The ISO/OSI model separates computer-to-computer communications into seven layers.
ISR
See interrupt service routine.
IST
See interrupt service thread.
ISV
Independent software vendor.
item script
An application written in HTML and Visual Basic Script, JScript, Java Script, or other scripting languages that specifies the behavior of an item within a channel.


K

kernel
The main module of the Windows CE operating system. The kernel provides system services for managing threads, memory, and resources.
key
A field or expression used to identify a record; often used as the index field for a database table.
key binary large object (key BLOB)
A key BLOB provides a way to store keys outside of the cryptographic service provider (CSP) and are used to transfer keys securely from one CSP to another. A key BLOB consists of a standard header followed by data representing the key.
key BLOB
See key binary large object.
key container
A place where cryptographic key pairs are stored. Each key container stores all of the key pairs belonging to a specific user.
keyboard accelerator
1. In applications, a key or key combination used to perform a defined function. Also called shortcut key. 2. In hardware, a device that speeds or enhances the operation of one or more subsystems, leading to improved application performance.


L

LAN
See local area network.
launch entry
A registry entry that specifies the order in which applications launch.
layered device driver
A sample device driver that comes with the Platform Builder. It contains two layers: a model device driver (MDD) layer and a platform-dependent driver (PDD) layer. See also model device driver and platform-dependent driver.
LBA
See logical block address.
lead-in
On an audio compact disc, the lead-in contains a table of contents for the track layout.
lead-out
On an audio compact disc, the lead-out indicates the end of data.
linked font
The font glyphs that you add to a base font when performing font linking. See also base font.
list box
A control that enables the user to choose one option from a list of possibilities. The list box appears as a box, displaying the currently selected option, next to a button marked with a down arrow. When the user clicks or taps the button, the list appears. The list has a scroll bar if there are more options than the list has room to show.
list view
A common control that displays a collection of items, such as files or folders. Each item has an icon and a label.
load file
A file that contains a list of commands for the Load function to process. You use load file commands to direct Ppcload.dll to create directories on a Windows CE–based device, copy files into the directories, edit registry entries, execute applications on the Windows CE–based device, and add items to the unload script. The fully qualified path of the load file is given as a command-line argument to Load.
local address
An address found on a local network.
local area network (LAN)
A group of computers and other devices dispersed over a relatively limited area and connected by a communications link that enables any device to interact with any other device on the network. LANs commonly include microcomputers and shared resources such as laser printers and large hard disks. The devices on a LAN are known as nodes, and the nodes are connected by cables through which messages are transmitted.
localization
The process of adapting an application for a specific international market, which includes translating the user interface, resizing dialog boxes, customizing features if necessary, and testing results to ensure that the application still functions properly.
logical block address (LBA)
A method of expressing a data address on a storage medium, such as a compact disc.
logical font
An application-defined description of a font. See also font mapping.
logical palette
An array of colors, or a color palette, that an application creates and associates with a device context and uses for graphics output.
Logical Service Access Point (LSAP)
The point of access to a service or application within Infrared Link Management Protocol (IrLMP). This access point is referenced with an LSAP selector (LSAP-SEL).
Logical Service Access Point Selector (LSAP-SEL)
A 1-byte number that corresponds to a Logical Service Access Point (LSAP). This byte is broken into ranges for the Information Access Service (IAS) server, legal connections, connectionless service, and future use.
LSAP
See Logical Service Access Point.
LSAP-SEL
See Logical Service Access Point Selector.


M

main priority
One of three thread priority groups. Main is the default priority. See also idle priority and interrupt priority.
main window
The window that serves as the primary interface between a user and an application.
major axis
A line whose length is one of the parameters used to describe the shape of an ellipse. The major axis has endpoints on the ellipse and passes through the two foci of the ellipse. See also focus.
MDD
See model device driver.
MDI
See multiple-document interface.
mean anomaly
An angular measurement that specifies the position of a satellite within the orbit of that satellite. The time that the satellite takes to complete one orbit maps to 2 pi radians of mean anomaly. Zero radians corresponds to the perigee and pi radians corresponds to the apogee. The mean anomaly of any other point in the orbit is proportional to the amount of time that the satellite takes to travel from the perigee to that point.
menu
A list of options from which a user can make a selection in order to perform a selected action, such as choosing a command or applying a particular format to part of a document. Many applications, especially those that offer a graphical interface, use menus as a means of providing a user with an easily learned, easy-to-use alternative to memorizing commands and their appropriate usage.
menu handle
A unique value of type HMENU used to identify a menu.
menu item
A string or bitmap displayed in a menu. Choosing a menu item either sends a command message or activates a pop-up menu.
menu template
A menu template defines a menu, including the items on a menu bar and all submenus.
message
A structure or set of parameters used for communicating information or a request. Messages can be passed between the operating system and an application, different applications, threads within an application, and windows within an application.
message box
A secondary window that is displayed to inform a user about a particular condition.
message digest
See hash value.
message handler
A Component Object Model (COM) object that implements the ITranslate interface in an in-process COM object.
message identifier
A unique value that identifies a message. System-defined messages use named constants, such as WM_PAINT, as message identifiers. Windows CE reserves message-identifier values in the range 0x0400 through 0x7FFF for application-defined messages.
message queue
An ordered list of messages awaiting transmission, from which they are taken up on a first-in, first-out (FIFO) basis.
message sink
A callback function that receives messages for a form or a control. Forms or controls that need to be notified of messages implement a message sink.
message store
The database in the object store for storing mail messages.
MFC
See Microsoft Foundation Classes.
Microsoft Foundation Classes (MFC)
The C++ class library that Microsoft provides with its C++ compiler to assist programmers in creating Windows-based applications. MFC hides the fundamental Windows API in class hierarchies so that programmers can write a Windows-based application without needing to know the details of the native Windows API.
Mobile Channels
A Windows CE technology that represents a fourth type of Internet Explorer 4.0 (IE4) channel to allow the user to access the Web with great mobility.
modal dialog box
A modal dialog box requires the user to supply information or close the dialog box before allowing the application to continue.
model device driver (MDD)
The platform-neutral layer of a native device driver supplied by Microsoft. See also native device driver.
modeless dialog box
A dialog box that allows the user to supply information and return to a previous task without closing the dialog box.
module
A subset of the Windows CE operating system. Windows CE is structured as a collection of modules. Each module is a self-contained subset of the Windows CE operating system that can be used to construct a customized operating system for a particular device.
monolithic device driver
A sample device driver that comes with the Microsoft Windows CE Platform Builder.
month calendar control
A child window that displays a monthly calendar. The calendar can display one or more months at a time.
mounted file system
A file system located on a removable medium, such as a PC Card storage device. The operating system loads, or mounts, the file system when the medium is inserted into the device. It unloads, or unmounts, the file system either when the medium is removed or when the user issues a command to do so.
MSF
A data address format that displays a data address in minutes, seconds, and frames.
multicast
A communication between a single sender and multiple receivers on a network.
multicast group
Collectively, the hosts listening to a specific Internet Protocol (IP) multicast address.
multimedia driver
A device driver that uses the Windows CE subset of the Win32 WDM device driver model.
multiple-document interface (MDI)
A user interface in an application that allows a user to have more than one document open at the same time. MDI is not supported by Windows CE.
mutex object
An interprocess synchronization object whose state is set to signaled when it is not owned by any thread, and nonsignaled when it is owned. Only one thread at a time can own a mutex object.


N

NaN
Not a number.
national language support (NLS)
A function that enables you to specify system and user locale information.
native device driver
A software component that enables a computer system to communicate with a device. In Windows CE, a native device driver is linked with the GWES component. The driver consists of a model device driver (MDD) layer and a platform-dependent driver (PDD) layer. Together, these layers make it possible for applications to access physically different, but functionally equivalent, hardware resources in the same way on all Windows CE–based platforms. Also called a built-in device driver.
navigation control
On a device, a moveable piece, such as a wheel or key, that sends virtual key codes. These virtual key codes are often used to move the cursor, alter the view of the current document, or launch a new application. A navigation control usually exists on a device that does not require a full hardware keyboard, such as a Palm-size PC.
NDIS
See Network Driver Interface Specification.
NDIS driver
A device driver for NDIS network adapters.
Network Driver Interface Specification (NDIS)
A programming interface that allows different protocols to share the same network hardware.
network identifier
An identifier for systems located on the same physical network.
network stack
An operating system component responsible for processing data that is transmitted or received over a network.
NLS
See national language support.
node
1. In local area networks, a device that is connected to the network and is capable of communicating with other network devices. 2. In tree structures, a location on the tree that can have links to one or more nodes below it. Some authors make a distinction between node and element, with an element being a given data type and a node comprising one or more elements as well as any supporting data structures.
nonclient area
The parts of a window that are not a part of the client area. A window’s nonclient area consists of the border, menu bar, title bar, and scroll bar.
nonsignaled
See synchronization object.
notification
A signal from the operating system that an event has occurred. This could be a timer event or a system event such as establishing a network connection. An application registers a notification for an event and the system generates a notification when the event occurs. Windows CE provides an application programming interface (API) that can be used to register events and select options that determine the type of notification.
notification function
A Windows CE function that allows an application to register its name and an event with the system. When the event occurs, the kernel automatically starts the named application.
notification message
A message that a control sends to its parent window when events, such as input from the user, occur.


O

OAL
See OEM adaptation layer.
object
A file, directory, database, or database record that resides in an object store.
object ID
See object identifier.
object identifier
1. A unique value that identifies each object in the object store. 2. In reference to the Contacts database, an object identifier is a unique value that the system assigns to each address card when it is added. An application uses the object identifier when querying an address card’s properties or when modifying or deleting an address card.
Object Linking and Embedding
See OLE.
object store
The persistent storage that Windows CE makes available to applications. For example, Windows CE reserves part of its available random access memory (RAM) for the operating system and uses the rest for the object store. This data can be stored in files, registry entries, or in Windows CE databases.
object type
A name for a particular group of objects that are contained in a folder. For example, appointment is an object type naming all appointments in a Microsoft Schedule+ folder.
OEM
See original equipment manufacturer.
OEM adaptation layer (OAL)
That portion of Windows CE that must be provided by the hardware manufacture to adapt Windows CE to their platform.
OLE
Object Linking and Embedding. A technology for transferring and sharing information among applications. When an object, such as an image file created with a painting application, is linked to a compound document, such as a spreadsheet or a document created with a word processing application, the document contains only a reference to the object; any changes made to the contents of a linked object are seen in the compound document. When an object is embedded in a compound document, the document contains a copy of the object; any changes made to the contents of the original object are not seen in the compound document unless the embedded object is updated. See also Automation.
option button
In graphical user interfaces, a means of selecting one of several options, usually within a dialog box. An option button, also known as a radio button, appears as a small circle that, when selected, has a smaller, filled circle inside it. Option buttons act like the station selector buttons on a car radio. Selecting one button in a set deselects the previously selected button, so one and only one of the options in the set can be selected at any given time. In contrast, check boxes are used when more than one option in the set can be selected at the same time.
original equipment manufacturer (OEM)
For Windows CE, an OEM is a company that manufacturers a hardware platform and ports Windows CE to that platform.
overlapped communication operation
The performance of two distinct communication operations simultaneously; for example, a simultaneous read/write operation. Windows CE does not support overlapped communication operation, but does support multiple read/writes pending on a device.
overlapped window
A window with the WS_OVERLAPPED style. Overlapped windows are top-level windows designed to serve as an application’s main window.


P

packet
A unit of information transmitted as a whole from one device to another on a network.
paint cycle
The process of a control painting or erasing itself in response to messages received from the operating system.
palette
A collection of colors that can be displayed on an output device.
parallel port
The input/output connector for a parallel interface device.
parent window
A window that has one or more child windows.
parser
An application that breaks data into smaller chunks so that an application can act upon the information. For example, Mobile Channels use a Channel Definition Format parser to parse a channel.
pASP
See pocket Active Server Pages.
path
1. In communications, a link between two nodes in a network. 2. A route through a structured collection of information, as in a database, an application, or files stored on disk. 3. In programming, the sequence of instructions that a computer carries out in executing a routine. 4. In file storage, the route followed by the operating system in finding, sorting, and retrieving files on a disk. 5. In graphics, an accumulation of line segments or curves to be filled or overwritten with text.
PC Card storage device
A trademark of the Personal Computer Memory Card International Association (PCMCIA) that is used to describe add-in cards that conform to the PCMCIA specification. A PC Card storage device is a removable device approximately the same size as a credit card that is designed to plug into a PCMCIA slot. Type I cards are primarily used as memory-related peripherals. Type II cards accommodate devices such as modem, fax, and network cards. Type III cards accommodate devices that require more space, such as wireless communications devices and rotating storage media, including hard disks. Flash card is a general term for a PC Card storage device.
PCT
See program comprehension tool.
PDD
See platform-dependent driver.
peer
Any of the devices on a layered communications network that operate on the same protocol level.
pen
A drawing tool used to draw lines and curves.
perigee
The point within the orbit of a satellite where the satellite is closest to the earth.
persistent object
A COM object that adheres to standards through which clients can request objects to be initialized, loaded, and saved to and from a data store, such as a flat file, structured storage, or memory.
personal information manager (PIM)
An application that usually includes an address book and organizes unrelated information, such as notes, appointments, and names, in a useful way.
phone book
Entries in the Remote Access Service (RAS) phone book contain the information necessary to establish a RAS connection. Unlike Windows NT, which keeps the phone book entries in a file, Windows CE stores these entries in the registry.
physical font
The font that is stored on a device or in an operating system. See also font mapping.
PIM
See personal information manager.
ping
A protocol for testing whether a particular computer is connected to the Internet by sending a packet to its Internet Protocol (IP) address and waiting for a response.
plaintext
Data that has not been encrypted.
platform
1. The foundation technology of a computer system. Because computers are layered devices composed of a chip-level hardware layer, a firmware and operating-system layer, and an applications layer, the bottommost layer of a machine is often called a platform. 2. In everyday usage, the type of computer or operating system being used. 3. The hardware upon which an implementation of Windows CE runs. 4. The directory structure containing the hardware-specific files needed to build an implementation of Windows CE.
platform-dependent driver (PDD)
The platform-specific layer of a native device driver supplied by an original equipment manufacturer. See also native device driver.
platform directory
The root of the directory structure where platform-specific files are stored. Each subdirectory in the platform directory specifies the name of a development workstation.
pocket Active Server Pages (pASP)
A scaled-down version of the Active Server Pages optimized for server-side Mobile Channels scripting.
Point-to-Point Protocol (PPP)
An advanced serial packet protocol commonly used for dial-up connections.
POP3
See Post Office Protocol 3.
pop-up menu
A menu that appears on the screen when a user selects a certain item. Pop-up menus can appear anywhere on the screen, and they generally disappear when the user selects an item in the menu.
pop-up window
A special type of overlapped window typically used for dialog boxes, message boxes, and other temporary windows that appear outside an application’s main window.
Portable Operating System Interface for Computer Environments (POSIX)
An IEEE standard that defines the open systems environment standards for system interfaces, shells, tools, testing, verification, real-time processing, security, system administration, networking, and transaction processing. The standard is based on UNIX system services, but it allows implementation on other operating systems.
position index
An identifier associated with each address card in the Contacts database. The position index indicates the address card’s position relative to the other address cards in the database. A position index is distinct from an object identifier.
POSIX
See Portable Operating System Interface for Computer Environments.
Post Office Protocol 3 (POP3)
A standard protocol for transferring mail messages on demand from a mail server.
PPP
See Point-to-Point Protocol.
predefined control
A control belonging to a window class supplied by Windows CE.
pre-emphasis
Increases the magnitude of the higher signal frequencies on an audio channel, improving the signal-to-noise ratio. Compare de-emphasis.
preemptive multitasking
A form of multitasking in which the operating system periodically interrupts the execution of an application and passes control of the system to another waiting application. Preemptive multitasking prevents any one application from monopolizing the system.
prerecorded speech template
A recording of a speech command in your application that is used for short voice Help.
principal
An entity recognized by a security system. A principal can be a human user or an autonomous process.
priority class
A range of thread priority levels. Whereas Win32 utilizes four priority classes with seven base priority levels per class, Windows CE has only eight base priority levels. Hence, for processes running under Windows CE, preemption is based solely on the thread’s priority.
priority inheritance
A process by which a thread that is blocking a shared resource needed by a higher-priority thread inherits the priority of that higher-priority thread in order to free the resource for use by the higher-priority thread, thus preventing priority inversion.
priority inversion
Priority inversion is a situation in which higher-priority thread A spawns lower-priority thread B to access a shared resource that is already in use by lower-priority thread C with greater priority than thread B, blocking higher-priority thread A. This situation can be averted by a process of priority inheritance.
process
A running application that consists of a private virtual address space, code, data, and other operating-system resources, such as files, pipes, and synchronization objects that are visible to the process. A process also contains one or more threads that run in the context of the process.
program button
On a device, a navigation control that is pressed to launch an application. The program button can also be programmed for additional features, such as creating a new document in an application.
program comprehension tool (PCT)
A software engineering tool that facilitates the process of understanding the structure and/or functionality of computer applications.
program memory
Program memory is used for stack and heap storage for both system and non-system applications. Non-system applications are taken from storage memory, uncompressed, and loaded into program memory for execution.
progress bar
A common control that indicates the progress of a lengthy operation by displaying a colored bar inside a horizontal rectangle. The length of the bar in relation to the length of the rectangle corresponds to the percentage of the operation that is complete.
project
1. The implementation of an instance of Windows CE. 2. The directory structure, under Public, containing files that define which components will be included in an implementation of Windows CE.
property
With respect to the database application programming interface, a property refers to a data item that consists of a property identifier, data type, and value. Windows CE supports several data types such as integer, string, time, and binary large object (BLOB).
property sheet
A type of dialog box that lists the attributes or settings of an object, such as a file, application, or hardware device. A property sheet presents the user with a tabbed, index card–like selection of property pages, each of which features standard dialog box–style controls for customizing parameters.
protocol stack
Collectively, the layers of communications software in the ISO/OSI model.
public-key encryption
An asymmetric scheme that uses a pair of keys for encryption: The public key encrypts data, and a corresponding secret key decrypts it. For digital signatures, the process is reversed: The sender uses the secret key to create a unique electronic number that can be read by anyone possessing the corresponding public key, which verifies that the message is truly from the sender.
pull-down menu
A menu containing commands that are accessed from a command or menu bar. A pull-down menu usually provides access to a small number of items with content that rarely changes.
push button
A small rectangular control that a user can turn on or off. A push button, also known as a command button, has a raised appearance in its default off state and a depressed appearance when it is turned on.


Q

queued message
A message in a message queue.
QWERTY keyboard
A keyboard layout named for the six leftmost characters in the top row of alphabetic characters on most keyboards—the standard layout of most typewriters and computer keyboards.


R

radio button
See option button.
RAM
See random access memory.
random access memory (RAM)
Semiconductor-based memory that can be read and written by the CPU or other hardware devices.
RAPI
See remote application programming interface.
RAS
See remote access server and Remote Access Service.
raster font
A font in which each glyph—a character or symbol—is of a particular size and style, designed for a specific resolution of device and described as a unique bitmap. There are seven system raster fonts available in several sizes stored in the Windows CE read-only memory (ROM). The built-in fonts are built into the Windows CE operating system. Also called bitmap fonts and non-scalable fonts.
raw infrared (raw IR)
A method of receiving data through an infrared transceiver. Raw IR treats the IR transceiver like a serial cable and does not process data in any way. The application is responsible for handling collision detection and other potential problems.
raw IR
See raw infrared.
read-only memory (ROM)
Any semiconductor circuit serving as a memory that contains instructions or data that can be read but not modified, regardless of whether it was placed there by a manufacturer or by a programming process.
rebar control
A rebar control acts as a container for child windows. A rebar control contains one or more bands. Each band can contain one child window, which can be a toolbar or any other control.
record
A data structure that is a collection of elements, each with its own name and type. The elements of a record represent different types of information and are accessed by name. A record can be accessed as a collective unit of elements, or the elements can be accessed individually. A collection of records is a database. A Windows CE database consists of an arbitrary number of records, where each record consists of one or more properties. Each of the records in a specific database typically contain a similar set of properties. A Windows CE database should not be confused with a full-fledged relational database. It is simply a general-purpose, flexible, structured collection of data.
rectangle
A function that draws a rectangular image.
Red Book audio
A data format standard for an audio compact disc.
redirector
A module through which one computer accesses another.
reentrant code
Code written so that it can be shared by several applications or threads within a single process simultaneously. When code is reentrant, one thread can safely interrupt the execution of another thread, execute its own code, and then return control to the first thread in such a way that the first thread does not fail or behave in an unexpected way.
region
A rectangle, polygon, ellipse, or a combination of two or more of these shapes used by Windows-based applications to define a part of the client area to be painted, inverted, filled with output, framed, or used for hit testing.
registered notification
The state of a user notification from the time CeSetUserNotification is called until the time the user is notified.
registry
A central hierarchical database used to store information necessary to configure the system for applications and hardware devices. The registry contains information—such as the applications installed on the computer and the types of documents each can create, property sheet settings for folders and application icons, what hardware exists on the system, and which ports are being used—that the operating system continually references during operation.
remote access server (RAS)
A Windows NT feature by which a single serial connection provides a remote workstation with host connectivity, NT file services, or Novell file and printing services (NWLink). Windows CE supports the standard Win32 RAS functions; however, it allows only one connection at a time. RAS functions can be implemented for direct serial connections or dial-up modem connections. See also Remote Access Service.
Remote Access Service (RAS)
Windows software that allows a user to gain remote access to the network server by means of a modem. See also remote access server.
remote address
An address not found on a local network.
remote application programming interface (RAPI)
Enables an application running on a desktop computer to make function calls on a Windows CE–based device. The desktop computer is known as the RAPI client and the Windows CE device is known as the RAPI server. RAPI runs over Winsock and TCP/IP.
Request for Comments (RFC)
A document in which a standard, a protocol, or other information pertaining to the operation of the Internet is published.
resistive touch panel
A transparent, touch-sensitive surface implemented to detect user input. See touch screen.
resource
1. Any part of a computer system or a network, such as a disk drive, a printer, or memory, that can be allotted to an application or a process while it is running. 2. An item of data or code that can be used by more than one application or in more than one place in an application, such as a dialog box, a sound effect, or a font in a windowing environment. Many features in an application can be altered by adding or replacing resources without the necessity of recompiling the application from source code. Resources can also be copied and pasted from one application into another, typically by a specialized utility application called a resource editor.
RFC
See Request for Comments.
Rich Ink
The underlying technology that enables a user to write and draw on a touch-sensitive screen by using a stylus.
right ascension
The angle as measured from the center of the earth between a satellite and the vernal equinox. The right ascension must have a value between 0 and 2 pi radians. See also vernal equinox.
RLE
See run-length encoding.
rocker switch
A hardware navigation control designed to perform spatial navigation, much like the UP ARROW key and the DOWN ARROW key.
ROM
See read-only memory.
ROM image
Files and binaries as they appear in physical memory as defined by the binary image builder (.bib) file.
router
An intermediary device on a communications network that expedites message delivery. On a single network linking many computers through a mesh of possible connections, a router receives transmitted messages and forwards them to their correct destinations over the most efficient available route. On an interconnected set of local area networks using the same communications protocols, a router serves the somewhat different function of acting as a link between these local area networks, enabling messages to be sent from one network to another.
run-length encoding (RLE)
A simple compression method that replaces a contiguous series (run) of identical values in a data stream with a pair of values that represent the length of the series and the value itself. For example, a data stream that contains 57 consecutive entries with the value 10 could replace them all with the much shorter pair of values 57, 10.


S

salt value
Random data used to supplement encryption schemes. A salt value allows two identical packets of data to be encrypted into two different packets of ciphertext using the same key by changing the salt value with each packet.
satellite azimuth
An angular measure of the horizontal direction of a satellite relative to an observer on Earth. The value of the satellite azimuth must be between 0 and 2 pi radians.
satellite elevation
The angular position of a satellite above the plane that is tangent to the earth at the position of the observer. The value of the satellite elevation must be between 0 and one-half pi radians.
scan code
A code number transmitted to a computer whenever a key is pressed or released. Each key on the keyboard has a unique scan code. This code is not the same as the ASCII code for the letter, number, or symbol shown on the key; it is a special identifier for the key itself and is always the same for a particular key. When a key is pressed, the scan code is transmitted to the computer, where a portion of the read-only memory basic input/output system (ROM BIOS) dedicated to the keyboard translates the scan code into its ASCII equivalent. Because a single key can generate more than one character—lowercase “a” and uppercase “A,” for example—the ROM BIOS also keeps track of the status of keys that change the keyboard state, such as the SHIFT key, and takes them into account when translating a scan code.
score
When referring to a spelling checker, a score is a number that indicates how much a replacement word differs from the original misspelled word. A low score indicates that the misspelled word was changed slightly, while a high score indicates that the word was changed a great deal.
script
An application consisting of a set of instructions to an application or utility application. The instructions usually use the rules and syntax of the application or utility.
scripting language
A simple programming language designed to perform special or limited tasks, sometimes associated with a particular application or function. An example of a scripting language is Visual Basic Script.
scroll bar
In some graphical user interfaces, a vertical or horizontal bar at the side or bottom of a display area that can be used with a mouse for moving around in that area. Scroll bars often have four active areas: two scroll arrows for moving line by line, a sliding scroll box for moving to an arbitrary location in the display area, and the gray areas in the scroll bar for moving in one-window increments.
scrolling menu
A menu with top arrows used to scroll menu items up and down.
Secure Sockets Layer (SSL)
A proposed open standard developed by Netscape Communications for establishing a secure communication channel to prevent the interception of critical information, such as credit card numbers. The primary purpose of the SSL is to enable secure electronic financial transactions on the Web, although it is designed to work with other Internet services as well.
security context
The security data relevant to a connection. A security context contains information such as a session key and the duration of a session. Both the client and server in a communication link must cooperate to create a security context.
security package
A security solution that maps Security Support Provider Interface (SSPI) functions to the security protocols specified in a package.
Security Support Provider (SSP)
A dynamic-link library (DLL) containing common authentication and cryptographic data schemes. See Security Support Provider Interface.
Security Support Provider Interface (SSPI)
Enables applications to access dynamic-link libraries (DLLs) containing common authentication and cryptographic data schemes. See Security Support Provider.
separator
A blank space used to divide toolbar elements into groups or to reserve space in a command bar.
serial cable
A cable that connects to a serial port. It is used to transfer information between two devices. See also serial port.
Serial Infrared (SIR)
Part of the basic Infrared Data Association (IrDA) communication protocol, a Serial Infrared physical layer provides for serial infrared links.
serial I/O
A communications channel that transmits data one bit at a time.
serialize
The process of converting an object to a series of bytes for transmission to another device. Compare deserialize.
Serial Line Internet Protocol (SLIP)
A data link protocol that allows transmission of Internet Protocol (IP) data packets over dial-up telephone connections, thus enabling a computer or a local area network to be connected to the Internet or some other network.
serial port
An input/output location (channel) that sends and receives data to and from a computer’s central processing unit or a communications device one bit at a time. Serial ports are used for serial data communication and as interfaces to peripheral devices, such as mouse devices and printers.
server
1. On a local area network (LAN), a computer running administrative software that controls access to the network and its resources, such as printers and disk drives, and provides resources to computers functioning as workstations on the network. 2. An application that responds to requests from another application or task. See also client.
service identifier
An identifier used by a service to uniquely identify messages. This value should be changed only by the service library.
service manager
A synchronization engine that resides on both the desktop computer and the device. The service manager performs many common synchronization tasks, which include providing connectivity, detecting changes in data, and resolving data conflicts, as well as mapping and transferring data objects.
service provider
When referring to ActiveSync technology, a service provider is a pair of DLLs that a developer must implement in an application in order to perform synchronization tasks. One module, called the desktop provider module, resides on the desktop computer and the other module, called the device provider module, resides on the device. See also desktop provider module and device provider module.
session identifier
An identifier generated by a mail transport service. Each time a Post Office Protocol 3 (POP3) connection is made to the server, the server looks at all of the currently stored messages and assigns a session identifier to each message, numbered 1 through the total number of messages. This makes it easier to reference a particular message without having to use its long unique identifier. The session identifier can be trusted only during a single connection to the mail server.
session key
A key used in symmetric encryption schemes where a single key is used to both encrypt and decrypt data.
SGML
See Standard Generalized Markup Language.
shared directory
On a local area network, a directory on a disk that is located on a computer other than the one a user is operating. A shared directory differs from a network drive in that a user has access to only that directory.
shared library
Any code module that can be accessed and used by many applications. Shared libraries are used primarily for sharing common code between different executable files or for breaking an application into separate components, thus allowing easy upgrades. In Windows CE, shared libraries are usually referred to as dynamic-link libraries (DLLs).
shell
An application that enables the user to connect with the kernel and, thus the system, usually providing some basic services in addition to facilitating the loading and executing of applications.
sibling window
A child window that has the same parent window as one or more other child windows.
signaled
See synchronization object.
signature file
A file that ensures that a cryptographic service provider (CSP) will be recognized by the operating system.
silkscreen button
A section of a resistive touch panel with a painted icon. An OEM provides a driver that lets this section of the panel send virtual-key messages. A silkscreen button is considered a navigation control.
silkscreen region
A section of a resistive touch panel that contains several silkscreen buttons.
Simple Mail Transfer Protocol (SMTP)
A TCP/IP protocol for sending messages from one computer to another on a network. This protocol is used on the Internet to route e-mail. See also TCP/IP.
single threading model
A model in which all objects are executed on a single thread. Contrast multithreaded application; see also free threading model, apartment threading model.
SIR
See Serial Infrared.
SLIP
See Serial Line Internet Protocol.
SMTP
See Simple Mail Transfer Protocol.
socket
An object that represents an endpoint for communication between processes across a network transport. Sockets have a datagram or stream type and can be bound to a specific network address. Windows Sockets provides an application programming interface (API) for handling all types of socket connections in Windows.
sort order
The order in which a set of records or other data objects are to be sorted, or the function that defines this order. Possible sort orders for an array of strings could include alphabetical order or ascending order by length, for example.
sound scheme
A collection of audio effects, such as clicks and beeps, associated with system and application key events.
speaker-dependent template
A recording of a speech command created by the user of a speech recognition system to train the system to recognize the command. Using a speaker-dependent template, a speech recognition system recognizes only the user who trained the word. See also speaker-independent template.
speaker-independent template
A synthesis of many speakers’ recorded pronunciation of a word or phrase. Using a speaker-independent template, a speech recognition system recognizes most speakers. See also speaker-dependent template.
speech recognition
The ability of a computer to understand the spoken word for the purpose of receiving commands and data input from the speaker.
spelling session
The resources that a spelling checker uses for a particular application, including dictionaries and created structures.
spin button control
A control containing a pair of arrow buttons that a user can tap with the stylus to increment or decrement a value. A spin button control is most often used with a companion control, called a buddy window, in which a current value is displayed. See also up-down control.
SSL
See secure socket layer.
SSP
See Security Support Provider.
stack
A region of reserved memory in which applications store status data such as procedure and function call addresses, passed parameters, and sometimes local variables.
Standard Generalized Markup Language (SGML)
An information-management standard adopted by the International Organization for Standardization (ISO) in 1986 as a means of providing platform-independent and application-independent documents that retain formatting, indexing, and linked information. SGML provides a grammar-like mechanism for users to define the structure of their documents and the tags they will use to denote the structure in individual documents.
static control
A control used to display text, to draw frames or lines separating other controls, or to display icons. A static control does not accept user input.
status bar
A space at the bottom of many application windows that contains a short text message about the current condition of the application. Some applications also display an explanation of the currently selected menu command in the status bar.
storage memory
Storage memory is similar to a RAM disk on a desktop computer. It is used to store data and nonsystem applications.
stream cipher mode
A method of encryption where data is encrypted one bit at a time. Compare block cipher mode.
stream interface device driver
A user-level DLL that controls devices connected to a Windows CE–based platform. A stream interface device driver presents the services of a hardware device to applications by exposing Win32 stream interface functions. Stream interface drivers also can control devices built into a Windows CE–based platform, depending on the software architecture for the drivers. Also called installable device driver.
stream mode
An asynchronous method of calling CeRapiInvoke by using an IStream type interface to exchange arbitrary-size data in any order and direction.
stylus
A pointing device used on a touch-sensitive surface.
subfolder
A directory, or logical grouping of related files, within another directory.
submenu
A menu that appears as the result of the selection of an item on a higher-level menu.
subnet mask
See address mask.
subnetwork
An identifiable and separate part of an organization’s network identified through Internet Protocol (IP) addresssing.
symbol
A name that represents a register, an absolute value, or a memory address (relative or absolute).
symmetric encryption
A type of encryption where the same key is used to encrypt and decrypt data.
synchronization
The process of updating information between the desktop computer and a Windows CE–based device to ensure that data is the same on both computers.
synchronization object
An object whose handle can be specified in one of the wait functions to coordinate the execution of multiple threads. A synchronization object will be a member of one of the synchronization classes. Synchronization classes are used when access to a resource must be controlled to ensure integrity of the resource. The state of a synchronization object is either signaled, which can allow the wait function to return, or nonsignaled, which can prevent the function from returning. More than one process can have a handle of the same synchronization object, making interprocess synchronization possible. There are four types of synchronization objects: mutex, semaphore, event, and critical section. Of these, Windows CE supports mutex, event, and critical section.
synchronous operation
1. Two or more processes that depend upon the occurrences of specific events such as common timing signals. 2. Data transmission method in which there is constant time between successive bits, characters, or events. The timing is achieved by the sharing of a single clock. Each end of the transmission synchronizes itself with the use of clocks and information sent along with the transmitted data. Characters are spaced by time, and not by start and stop bits. 3. A function call that blocks execution of a process until it returns. Compare asynchronous operation.
sysgen phase
Refers to the process of defining and building the selected modules and components, as governed by the Makefile located in the directory %_PUBLICROOT%\Common\Cesysgen.
system-defined message
A message that the system uses to control the operations of an application and to provide input and other information for an application to process. An application can also send or post a system-defined message. An application generally uses this message to control the operation of control windows created by using preregistered window classes.
system registry functions
The functions used to manipulate keys and values in the registry. A Windows CE–based application uses the standard Win32 registry functions.


T

tab control
A control that is analogous to a set of dividers in a notebook or labels in a file cabinet. A tab control is used in a property sheet to provide a way for a user to move from one property page to another.
TAPI
See Telephony Application Programming Interface.
target platform
The system for which Windows CE is being adapted.
TCP/IP
See Transmission Control Protocol/Internet Protocol.
telephony
Telephone technology; the conversion of sound into electrical signals, its transmission to another location, and its reconversion to sound, with or without the use of connecting wires.
Telephony Application Programming Interface (TAPI)
A set of functions in the Win32 API that lets a computer communicate directly with telephone systems. Windows CE supports TAPI version 1.5. It provides the basic functions, structures, and messages for establishing outgoing calls and controlling modems from a Windows CE–based device.
Telephony Service Provider (TSP)
A modem driver that enables access to vendor-specific equipment through a standard device driver interface. See also Telephony Service Provider Interface (TSPI).
Telephony Service Provider Interface (TSPI)
The external interface of a service provider to be implemented by vendors of telephony equipment. A telephony service provider accesses vendor-specific equipment through a standard device driver interface. Installing a service provider allows Windows CE–based applications that use elements of telephony to access the corresponding telephony equipment. See also Telephony Service Provider (TSPI).
TEXT
A Win32 macro that exists so that code can be compiled either as American Standard Code for Information Interchange (ASCII) text or as Unicode. For Windows CE, which supports only Unicode, the macro forces the compiler to convert ASCII characters to Unicode characters. For example, passing the ASCII string “Hello Windows CE!’’ through the TEXT macro converts all characters in the string to 16-bit wide characters.
text normalization
Changing how words are pronounced based on their context.
text-to-speech (TTS)
The conversion of text-based data into voice output by speech synthesis devices. Text-to-speech allows users to gain access to information audibly.
thread
A process that is part of a larger process or application. A thread can execute any part of an application’s code, including code that is currently being executed by another thread. All threads share the virtual address space, global variables, and operating-system resources of their respective processes.
thread identifier
The unique identifier associated with a specific thread. Note that thread identification numbers are reused; they identify a thread only for the lifetime of that thread.
thread local storage (TLS)
A Win32 mechanism that allows multiple threads of a process to store data that is unique for each thread. For example, a spreadsheet application can create a new instance of the same thread each time the user opens a new spreadsheet. A dynamic-link library that provides the functions for various spreadsheet operations can use thread local storage to save information about the current state of each spreadsheet.
thread synchronization
The method used to coordinate the execution of two or more threads. There are two states in synchronization, signaled and nonsignaled. Threads can either modify the state of the synchronization object or wait for the object to reach a signaled state.
time-out value
A specified time interval used by a timer. Each time the time-out value elapses, Windows CE sends a WM_TIMER message to the window associated with the timer.
timer
An internal routine that causes the system to send a WM_TIMER message whenever a specified interval elapses.
timestamping
The process of attaching the date and time to a message.
Time to Live
A header field for a packet sent over the Internet indicating how long the packet should be held.
TLB
See translation look-aside buffer.
TLS
See thread local storage.
toolbar
A row, column, or block of on-screen buttons or icons. When these buttons or icons are depressed, macros or certain functions of the application are activated.
ToolTip
A small rectangular pop-up window that displays a brief description of a command bar button’s purpose.
top-level window
A window that has no parent window.
topmost window
A window with the WS_EX_TOPMOST style. A topmost window overlaps all other non-topmost windows.
touchpad
An input device that functions like a mouse to control cursor movements.
touch panel
See touch screen.
touch screen
A computer screen on which the user selects options, such as from a menu, by touching the screen. The touch screen is composed of an LCD and a resistive touch panel.
trackbar
A common control, also known as a slider control, that consists of a bar with tick marks on it and a slider, also known as a thumb. When a user drags the slider or clicks on either side of it, the slider moves in the appropriate direction, tick by tick.
traffic
The load carried by a communications link or channel.
translation look-aside buffer (TLB)
A table used in a virtual memory system that lists the physical address page number associated with each virtual address page number. A TLB is used in conjunction with a cache whose tags are based on virtual addresses. The virtual address is presented simultaneously to the TLB and to the cache so that cache access and virtual-to-physical address translation can occur simultaneously.
Transmission Control Protocol/Internet Protocol (TCP/IP)
A protocol developed by the Department of Defense for communications between computers. It is built into the UNIX system and has become the de facto standard for data transmission over networks, including the Internet. TCP and IP are transport and address protocols; TCP is used to establish a connection for data transmission, and IP defines the method for sending the data in packets.
transport functions
A set of functions, exported by a mail transport service dynamic-link library, that are used to transfer mail messages from one location to another.
tree-view control
A hierarchical display of labeled items. The top item in the hierarchy is called the root. If an item has other items below it in the hierarchy, it is also referred to as a parent. Items subordinate to parents are called children. Child items, when displayed, are indented below their parent item. The hierarchy may be expanded or collapsed at any level to display or hide child items.
TrueType
A scalable outline font whose glyphs are stored as a collection of line and curve commands, plus a collection of hints.
TSP
See Telephony Service Provider.
TSPI
See Telephony Service Provider Interface.
TTS
See text-to-speech.


U

UNC
See Universal Naming Convention.
unicast
A communication between a single sender and a single receiver on a network.
Unicode
A 16-bit character set capable of encoding almost all known characters and used as a worldwide character-encoding standard. Windows CE uses Unicode exclusively at the system level.
Uniform Resource Identifier (URI)
See Uniform Resource Locator.
Uniform Resource Locator (URL)
The address of a resource on the Internet. URL syntax is in the form protocol://host/localinfo, where protocol specifies the means of returning the object, such as Hypertext Transfer Protocol (HTTP) or File Transfer Protocol (FTP). Host specifies the remote location where the object resides, and localinfo is a string—often a file name—passed to the protocol handler at the remote location. Also called Uniform Resource Identifier (URI).
Unimodem
1. The universal modem driver, provided with Windows CE, that translates Telephony Service Provider Interface (TSPI) calls into AT commands, and sends the commands to a virtual device driver that talks to the modem. 2. A universal modem that supports standard modem AT commands. Windows CE currently supports only PCMCIA modems.
universally unique identifier (UUID)
A 128-bit value that uniquely identifies objects such as OLE servers, interfaces, manager entry-point vectors, and client objects. Universally unique identifiers are used in cross-process communication, such as remote procedure calling (RPC) and OLE. Also called globally unique identifier (GUID).
Universal Naming Convention (UNC)
The system of naming files among computers on a network so that a file on a given computer will have the same path when it is accessed from any of the other computers on the network. For example, if the directory c:\path1\path2\...pathn on computer servern is shared under the name pathdirs, a user on another computer would open \\servern\pathdirs\filename.ext to access the file c:\path1\path2\...pathn\filename.ext on servern. See also Uniform Resource Locator.
universal serial bus (USB)
A serial bus with a bandwidth of 1.5 megabits per second (Mbps) for connecting peripherals to a microcomputer. USB can connect up to 127 peripherals, such as external CD-ROM drives, printers, modems, mouse devices, and keyboards, to the system through a single, general-purpose port. This is accomplished by daisy-chaining peripherals together. USB supports hot plugging and multiple data streams. Developed by Intel, USB competes with DEC's ACCESS.bus for lower-speed applications.
up-down control
A control containing a pair of arrow buttons that a user can click to increment or decrement a value, such as a scroll position. When used with an edit control or other type of companion control, an up-down control is referred to as a spin button. See spin button control.
URI
See Uniform Resource Locator.
URL
See Uniform Resource Locator.
USB
See universal serial bus.
USB driver
A device driver for USB-compatible devices.
user level driver
See stream interface device driver.
user notification
A warning to the user that a timer event has occurred. The notification may require the user to perform some action to handle the notification or may generate a sound to alert a user. For example, the system may display a dialog box and play a sound or display an icon before a scheduled appointment. The user would tap the dialog box OK button to acknowledge the appointment. User notifications are always associated with an application.
UUID
See universally unique identifier.


V

vernal equinox
A point that represents the apparent ascending node of the sun in the apparent orbit of the sun around the earth. For modeling purposes, pretending that the sun orbits the earth, rather than that the earth orbits the sun, simplifies the descriptions of satellite orbits. See also ascending node.
vehicle bus bridge
A hardware interface that connects between an Auto PC’s universal serial bus (USB) port and an automobile’s on-board diagnostic level II (OBD II) port.
virtual-key code
A device-independent value that identifies the purpose of a keystroke as interpreted by the Windows keyboard device driver.


W

wait function
Allows a thread to block its own execution. Wait functions do not return until the specified criteria have been met. The type of wait function determines the set of criteria used. When a wait function is called, it checks whether the wait criteria have been met. If the criteria have not been met, the calling thread enters an efficient wait state, consuming very little processor time while waiting for the criteria to be met. Windows CE supports only single object wait functions.
warm boot
Restarting a running computer without first turning off the power. Also called soft boot, warm start. Compare cold boot.
.wav
The file extension that identifies sound files stored in waveform (WAV) audio format.
Web Browser ActiveX control
An ActiveX control that programmers can use to add Internet browsing capabilities to applications.
Win32
The application programming interface in Windows 95, Windows NT, and Windows CE that enables applications to use the 32-bit instructions available on 80386 and higher processors.
window
A rectangular area on the screen where an application displays output and receives user input. On a Windows CE–based device that supports a graphical display, a window—rather than the screen itself—is the primary output device. Windows are also the means by which applications send and receive messages to the operating system. Therefore, all Windows CE–based applications—even those that lack a visual interface—need to create and manage windows.
window class
A set of attributes that Windows CE uses as a template to create a window. Each window class has a window procedure that processes messages for all windows of that class. Every window in a Windows CE–based application is a member of a window class.
window control
A predefined child window used in conjunction with another application window to provide a standardized way for users to make selections, carry out commands, and perform input and output tasks. Windows controls typically send WM_COMMAND messages.
window coordinate
The position of a window in relation to the upper-left corner of the screen or, for a child window, the upper-left corner of the parent window’s client area.
window handle
A 32-bit value, assigned by Windows CE, that uniquely identifies a window.
window procedure
A function, called by the operating system, that controls the appearance and behavior of its associated windows. The procedure receives and processes all messages to these windows.
Windows CE Services
A set of technologies that makes Windows CE–based devices Web-enabled. Its architecture is based on a multilayered client/server model that provides the functionality to deliver Web content information to Windows CE–based devices from a wireless network or by desktop synchronization.
Windows Internet Naming Service (WINS)
A distributed database for registering and querying dynamic name-to-IP address mappings in a routed network environment. When dynamic addressing through DHCP results in new IP addresses for computers that move between subnets, the changes are automatically updated in the WINS database.
Windows Sockets (Winsock)
A programming interface used to provide a protocol-independent transport interface. Windows CE supports most of the common Winsock functions.
window style
A named constant that defines an aspect of the window’s appearance and behavior not specified by the window’s class.
WinInet
An API that provides Internet access to applications using Hypertext Transfer Protocol (HTTP) and File Transfer Protocol (FTP).
WINS
See Windows Internet Naming Service.
Winsock
See Windows Sockets.
Wireless Push Server (WPS)
See Wireless Services server component.
Wireless Services client component
Decodes and processes messages from the Wireless Push Server (WPS). The client architecture allows for new decoding components to be installed at any time.
Wireless Services server component
Allows a content provider or carrier to configure and schedule any number of information acquisition/encoding/transmission components to create a data stream to be transmitted by a carrier to the device. The server component builds on an open architecture to allow new server components to be installed in any part of the stream at any time.
WPS
See Wireless Services server component.
wrapper function
A function that provides a simplified interface to another function, for example by changing the order of some parameters or by interpreting the return code.


X

X.509
An international message-handling standard for message authentication and encryption. X.509 is published by the Internal Telecommunications Union (ITU), formerly the International Telegraph and Telephone Consultative Committee (CCITT) standards body.
XIP
See execute in place.


Z

z-order
A stack of overlapping windows. Each window has a unique position in the z-order.
zeroth order clock correction
A rough numerical measure of the bias in the time reported by a Global Positioning System (GPS) satellite.